// Хранилище структуры меню
app.factory('menuProvider', ['$rootScope', 'locale', function ($rootScope, locale) {
    var service = {};

    var _RouteHierarchy = [];
    var _fillRouteHierarchy = function () {
        _RouteHierarchy.push({ RouteRoot: '/login', Alias: 'Аутентификация', ExcludeFromMenu: true });
        
        var routes = [
            {"RouteRoot":"UserManagement/Users","Id":"","Alias": locale.getString('common.users'),"IconClassName":"fa-users","Children":[]},
            {"RouteRoot":"UserManagement/Roles","Id":"","Alias": locale.getString('common.roles'),"IconClassName":"fa-pencil ","Children":[]}];

        angular.forEach(routes, function(route, index) {
            _RouteHierarchy.push(route);
        });
    };

    var _normaliseNodeChilldrenId = function(node, topIndex) {
        localindex = topIndex;
        if (node.Id)
            node.Id += '-' + topIndex;
        else
            node.Id = 'elem-' + localindex++;
        if (node.Children) {
            angular.forEach(node.Children, function(elem, index) {
                _normaliseNodeChilldrenId(elem, index);
            });
        }        
    };

    var _normaliseRouteHierarchyIds = function() {
        angular.forEach(_RouteHierarchy, function(elem, topIndex) {
            _normaliseNodeChilldrenId(elem, topIndex);
        })
    };

    locale.ready('common')
    .then(function() { 
        _fillRouteHierarchy();
        _normaliseRouteHierarchyIds();
        $rootScope.$broadcast('locationChange');
    })    

    // Возвращаем полную конфигурцию маршрутов
    service.GetRouteHierarchy = function () {
        return _RouteHierarchy;
    }

    return service;
}]);
